#include "18F4520.h"
#include <stdint.h>


#device adc=10
#device HIGH_INTS=TRUE
#FUSES  WDT,WDT2048,NOLVP//,NOXINST//,BORV45   //Watch Dog Timer
//#FUSES WDT, WDT512, PUT, BORV25, NOMCLR, NOSTVREN, NOLVP, NOXINST
#use delay(clock=40000000,crystal=10000000,RESTART_WDT)
#use rs232(baud=57600,parity=N,xmit=PIN_C6,rcv=PIN_C7,bits=8,stream=Vivod_1,restart_wdt,errors)

/////// //////////////////
	void BIN_2(unsigned int16 A_bin );
	void Vivod(void);
    void VIV_PR_0(void);
	void ISM_Init(void) ;
	void Zad_meazire(void);
	void VIV_ISM(void);
	void ISM_Podgot(void);    
	void spi_Write_ISM(unsigned char buffer_VIV1,unsigned char buffer_VIV2);
	void spi_Write_ISM_1(unsigned char buffer_VIV1,unsigned char buffer_VIV2);
	void spi_Write_ISM_2(unsigned char buffer_VIV1,unsigned char buffer_VIV2);
	void spi_Write_ISM_8(unsigned char buffer_VIV1);
	void spi_Read_IN(void);
 	unsigned char spi_Read_IN_8_1(void);
	unsigned char spi_Read_IN_8_2(void);
	void Ypravlenie(void);
	void  K_Symm_0 (void);
	void  K_Symm_1 (void);
	void  K_Symm_2 (void);
	void  K_Symm_3 (void);
	void  K_Symm_4 (void);
	void  K_Symm_5 (void);
	void  K_Symm_6 (void);
	void  K_Symm_7 (void);
	void  K_Symm_8 (void);
	void Osechka_Yst(void);
	void  K_Symm_PR (void);
	void  AB_Pr_NAL (void);
    void AB_Pr_NAL_2 (void);
	void AB_Pr_NAL_R_2 (void);
	void  Osechka_Podgotovka_Vivod (void);
	void Kartridge_Podgotovka_Vivod (void);
	void  K_Symm_Podt_Viv (void);
	void Podgotovka_Vivod_2 (void);
	void  K_Symm_Podt_Sinxro (void);
	void Donesenie_0(void);
	void Donesenie_1(void);
	void Donesenie_2(void);
	void Donesenie_3(void);
	void Donesenie_4(void);
	void Donesenie_5(void);
	void Donesenie_K_0(void);
	void Donesenie_K_1(void);
	void Donesenie_K_2(void);
	void Donesenie_K_3(void);
	void Donesenie_K_4(void);
	void Donesenie_K_5(void);
	void Katridge_Yst(void);
	void  Konfig_Read(void);
	void  Konfig_Write_Nk(void);
	void  Konfig_Write_N_AB(void);
	void Raspak_1 (void);
	void Raspak_AB_0_0(void);
	void Raspak_AB_1_0(void);
	void Raspak_AB_2_0(void);
	void Raspak_AB_3_0(void);
	void Raspak_AB_4_0(void);
	void Raspak_AB_5_0(void);
	void Raspak_AB_6_0(void);
	void Raspak_AB_7_0(void);
	void Raspak_AB_8_0(void);

	void Raspak_AB_0_1(void);
	void Raspak_AB_1_1(void);
	void Raspak_AB_2_1(void);
	void Raspak_AB_3_1(void);
	void Raspak_AB_4_1(void);
	void Raspak_AB_5_1(void);
	void Raspak_AB_6_1(void);
	void Raspak_AB_7_1(void);
	void Raspak_AB_8_1(void);

	void Raspak_AB_0_2(void);
	void Raspak_AB_1_2(void);
	void Raspak_AB_2_2(void);
	void Raspak_AB_3_2(void);
	void Raspak_AB_4_2(void);
	void Raspak_AB_5_2(void);
	void Raspak_AB_6_2(void);
	void Raspak_AB_7_2(void);
	void Raspak_AB_8_2(void);

	void Raspak_AB_0_3(void);
	void Raspak_AB_1_3(void);
	void Raspak_AB_2_3(void);
	void Raspak_AB_3_3(void);
	void Raspak_AB_4_3(void);
	void Raspak_AB_5_3(void);
	void Raspak_AB_6_3(void);
	void Raspak_AB_7_3(void);
	void Raspak_AB_8_3(void);

	void Raspak_AB_0_4(void);
	void Raspak_AB_1_4(void);
	void Raspak_AB_2_4(void);
	void Raspak_AB_3_4(void);
	void Raspak_AB_4_4(void);
	void Raspak_AB_5_4(void);
	void Raspak_AB_6_4(void);
	void Raspak_AB_7_4(void);
	void Raspak_AB_8_4(void);
	
	void Raspak_AB_0_10(void);
	void Raspak_AB_1_10(void);
	void Raspak_AB_2_10(void);
	void Raspak_AB_3_10(void);
	void Raspak_AB_4_10(void);
	void Raspak_AB_5_10(void);
	void Raspak_AB_6_10(void);
	void Raspak_AB_7_10(void);
	void Raspak_AB_8_10(void);

	void Raspak_Tip_0(void);
	void Raspak_Tip_1(void);
	void Raspak_Tip_2(void);
	void Raspak_Tip_3(void);
	void Raspak_Tip_4(void);
	void Raspak_Tip_5(void);
	void Raspak_Tip_6(void);
	void Raspak_Tip_7(void);
	void Raspak_Tip_8(void);
	void Raspak_Tip_10(void);
	void Format_Data_AB_0(void);
	void Format_Data_AB_1(void);
	void Format_Data_AB_2(void);
	void Format_Data_AB_3(void);
	void Format_Data_AB_4(void);
	void Format_Data_AB_5(void);
	void Format_Data_AB_6(void);
	void Format_Data_AB_7(void);
	void Format_Data_AB_8(void);
	void  ISM_Podgot_K(void);
	void  K_Symm_PR_2 (void);//  
	void ISM_Init_F(void); 
	void Konfig_Read_1(void);
	void Konfig_Write_N_AB(void);
	void Konfig_Eraze_N_AB(void);
    void Konfig_Read_AB(void);
	void Konfig_Write_AB(void);

    unsigned char spi_IN(unsigned char buffer_IN1);
	unsigned char spi_IN_2(unsigned char buffer_IN1); 


	unsigned char K_Symm_N( unsigned char CRC_8_data, unsigned char CRC_8_prev);
	unsigned char K_Symm_N_1( unsigned char CRC_8_data, unsigned char CRC_8_prev);
	unsigned char K_Symm_N_2( unsigned char CRC_8_data, unsigned char CRC_8_prev);
	unsigned char K_Symm_N_3( unsigned char CRC_8_data, unsigned char CRC_8_prev);
	unsigned char K_Symm_N_4( unsigned char CRC_8_data, unsigned char CRC_8_prev);
	unsigned char K_Symm_N_5( unsigned char CRC_8_data, unsigned char CRC_8_prev);
	
	void ism_set_work_channel();				  //    		(ISM_Modem.c)
	void ism_set_system_channel();				  //       (ISM_Modem.c)
	void ism_send_data(uint8_t* data_ptr);		  //       (ISM_Modem.c)
	uint8_t* ism_receive_data(uint8_t* data_ptr); //       (Raspakovka.c)
	 
	uint32_t time_now();	//       (Ypr-2.c)
	void ism_Calibrovka_RD(void);
	void ism_Calibrovka_TX(void);
	void Podgot_Vivod_N(void);	
#define CS_M		PIN_B1 //B4
#define SCK_M		PIN_B4 //A3
#define SDI_M		PIN_B2 //B3
#define SDO_M		PIN_B5 //A2
#define	FINT_M		PIN_B0 //B0
#define	nFSEL_M		PIN_B3 //B5
