 #include <Ypravlen-1.h>
//  #include <i2c.h>
  #include <MPU9250.h>


	 unsigned int16 	 V_1,X_Accel,Y_Accel,Z_Accel,X_Gyro,Y_Gyro,Z_Gyro,TEMPER;
	 unsigned char  Id_MPU9250,Id_AK_8963,data_ST1,data_ST2;
	 unsigned int16		X_Mag,Y_Mag,Z_Mag;

 void Init_9250 (void) 
	{
//-------  ---------------
    	i2c_stop();
//------------------------------------------
   	 I2C_write_9250 (MPU9250_SMPLRT_DIV, 0x07);       //25Rg Sets sample rate to 8000/1+7 = 1000Hz
   	 I2C_write_9250 (MPU9250_CONFIG, 0x03);           //26Rg Disable FSync, ___Hz DLPF
     I2C_write_9250 (MPU9250_GYRO_CONFIG, 0b00000000);//27Rg Disable gyro self tests, scale of 2000 degrees/s
  	 I2C_write_9250 (MPU9250_ACCEL_CONFIG, 0x00);	  //28Rg Disable accel self tests, scale of +-2g, no DHPF
  	 I2C_write_9250 (MPU9250_ACCEL_CONFIG2, 0x03);    //29Rg Freefall threshold of |0mg|
  	 I2C_write_9250 (MPU9250_FIFO_EN, 0x00);          //35Rg Disable sensor output to FIFO buffer
//-----------  ---------------------
	 I2C_write_9250 (MPU9250_I2C_MST_STATUS, 0x00);// 54
	 I2C_write_9250 (MPU9250_INT_PIN_CFG, 0x00);//  55
	 I2C_write_9250 (MPU9250_INT_ENABLE, 0x00);// 56
//-----------  . ---------------------
	 I2C_write_9250 (MPU9250_PWR_MGMT_1, 0x00);// 107
		delay_ms(100);
	 I2C_write_9250 (MPU9250_PWR_MGMT_1, 0x01);// 107
	 I2C_write_9250 (MPU9250_PWR_MGMT_2, (0b00000000));// 108
//----------- . ---------------------
	 I2C_write_9250 (MPU9250_ACCEL_CONFIG, 0x00);// 28
	 I2C_write_9250 (MPU9250_ACCEL_CONFIG2, 0x03);// 29
	 I2C_write_9250 (MPU9250_LP_ACCEL_ODR, 0x00);// 30
	 I2C_write_9250 (MPU9250_FIFO_EN, (0b11111000));// 35

//------    . -------------------   
	I2C_write_9250  (MPU9250_USER_CTRL, (0b01000000));
	I2C_write_9250  (MPU9250_INT_PIN_CFG, (0b00000010));
   	i2c_start();		//  i2c
  	i2c_write(MPU9250_MAG_ADDRESS_W);
   	i2c_write(MPU9250_MAG_CNTL);
   	i2c_write(0b00000110);
    i2c_stop();
	delay_ms(1);
	I2C_write_9250  (MPU9250_INT_PIN_CFG, (0b00000000));
//---------------------------------

	}
//-------  I2C-----------------
void I2C_write_9250 (unsigned char reg, unsigned char value) 
{
   i2c_start();
   i2c_write(MPU9250_W);
   i2c_write(reg);
   i2c_write(value);
   i2c_stop(); 
}
void i2c_Read_9250_Accel(void)

{
unsigned int16 data_1,data_2;
  
   	i2c_start();
  	i2c_write(MPU9250_W);
   	i2c_write(MPU9250_ACCEL_XOUT_H);
   	i2c_start();
  	i2c_write(MPU9250_R);
	data_1 = i2c_read(1);
	data_2 = i2c_read(0);
    i2c_stop(); 
 
	X_Accel=((data_1<<8)| data_2);
//==================================
   	i2c_start();
  	i2c_write(MPU9250_W);
   	i2c_write(MPU9250_ACCEL_YOUT_H);
   	i2c_start();
  	i2c_write(MPU9250_R);
	data_1 = i2c_read(1);
	data_2 = i2c_read(0);
    i2c_stop(); 
 
	Y_Accel=((data_1<<8)| data_2);
//==================================
   	i2c_start();
  	i2c_write(MPU9250_W);
   	i2c_write(MPU9250_ACCEL_ZOUT_H);
   	i2c_start();
  	i2c_write(MPU9250_R);
	data_1 = i2c_read(1);
	data_2 = i2c_read(0);
    i2c_stop(); 
 
	Z_Accel=((data_1<<8)| data_2);
//==================================

}
//===========================

void i2c_Read_9250_Giro(void)

{
unsigned int16 data_1,data_2;
  
   	i2c_start();
  	i2c_write(MPU9250_W);
   	i2c_write(MPU9250_GYRO_XOUT_H);
   	i2c_start();
  	i2c_write(MPU9250_R);
	data_1 = i2c_read(1);
	data_2 = i2c_read(0);
    i2c_stop(); 
 
	X_Gyro=((data_1<<8)| data_2);
//------------------------------
   	i2c_start();
  	i2c_write(MPU9250_W);
   	i2c_write(MPU9250_GYRO_YOUT_H);
   	i2c_start();
  	i2c_write(MPU9250_R);
	data_1 = i2c_read(1);
	data_2 = i2c_read(0);
    i2c_stop(); 
 
	Y_Gyro=((data_1<<8)| data_2);
//------------------------------
   	i2c_start();
  	i2c_write(MPU9250_W);
   	i2c_write(MPU9250_GYRO_ZOUT_H);
   	i2c_start();
  	i2c_write(MPU9250_R);
	data_1 = i2c_read(1);
	data_2 = i2c_read(0);
    i2c_stop(); 
 
	Z_Gyro=((data_1<<8)| data_2);
//------------------------------

}

//========T==========================
void GET_TEMPER (void) 
{
unsigned int16 data_1,data_2;

   	i2c_start();		//  i2c
  	i2c_write(MPU9250_W);
   	i2c_write(MPU9250_TEMP_OUT_H);
   	i2c_start();
  	i2c_write(MPU9250_R);
	data_1 = i2c_read(1);	//  
	data_2 = i2c_read(0);	//  
    i2c_stop(); 
 
	TEMPER=((data_1<<8)| data_2);
}
//---------------------------------------------
//========Id_MPU9250==========================
void Identfik_1 (void) 
{
unsigned int16 data_1,data_2;

   	i2c_start();		//  i2c
  	i2c_write(MPU9250_W);
   	i2c_write(MPU9250_WHO_AM_I);
   	i2c_start();
  	i2c_write(MPU9250_R);
	data_1 = i2c_read(1);	//  
	data_2 = i2c_read(0);	//  
    i2c_stop(); 
 
	Id_MPU9250=(data_1);
}
//---------------------------------------------
//========Id_AK_8963==========================
void Identfik_2 (void) 
{
unsigned int16 data_1,data_2;
	I2C_write_9250  (MPU9250_USER_CTRL, (0b01000000));
	I2C_write_9250  (MPU9250_INT_PIN_CFG, (0b00000010));
	i2c_start();
  	i2c_write(MPU9250_MAG_ADDRESS_W);
   	i2c_write(MPU9250_MAG_WIA);
	i2c_start();
  	i2c_write(MPU9250_MAG_ADDRESS_R);
	data_1 = i2c_read(1);	//  
	data_2 = i2c_read(0);	//  
    i2c_stop(); 
 	 
	Id_AK_8963=(data_1);
	I2C_write_9250  (MPU9250_INT_PIN_CFG, (0b00000000));
}
//---------------------------------------------

//========_AK_8963==========================
void Meazire (void) 
{
	unsigned int16 data_1,data_2 ;
	unsigned char N_cikl;
	I2C_write_9250  (MPU9250_USER_CTRL, (0b01000000));
	I2C_write_9250  (MPU9250_INT_PIN_CFG, (0b00000010));
	N_cikl=0;
mz1:
	i2c_start();
  	i2c_write(MPU9250_MAG_ADDRESS_W);
   	i2c_write(MPU9250_MAG_ST1);
	i2c_start();
  	i2c_write(MPU9250_MAG_ADDRESS_R);
	data_ST1 = i2c_read(1);	//  
	if (!bit_test (data_ST1, 0))
	{
	data_1 = i2c_read(0);	//     .	
	i2c_stop();
  //-----N_cikl-----------
	N_cikl++;
	if(N_cikl>20)
	{N_cikl=0;
	goto mz2;		
	}
  //----------------------	
	goto mz1;
	}
	data_1 = i2c_read(1);	//  
	data_2 = i2c_read(1);	//  
	X_Mag=((data_1<<8)| data_2);
	delay_us(100);	
	data_1 = i2c_read(1);	//  
	data_2 = i2c_read(1);	//  
	Y_Mag=((data_1<<8)| data_2);
	delay_us(100);
	data_1 = i2c_read(1);	//  
	data_2 = i2c_read(1);	//  
	Z_Mag=((data_1<<8)| data_2);
	delay_us(100);

	data_ST2 = i2c_read(0);	//  

mz2:
	I2C_write_9250  (MPU9250_INT_PIN_CFG, (0b00000000));
}
//---------------------------------------------



// ========================================================================================================================
// ========================================================================================================================

/*


GET_TEMPER();
t=TEMPER_h*256;
t=t+TEMPER_l+12412;
t=t/340;
//t=t*100;
//t=t+3653;
//t=t/100;
LCD_Goto(0,2);
LCD_WriteData('t');
LCD_WriteData('=');
BCD_2Lcd(t);

*/


